/* Open SoundControl kit in C++                                              */
/* Copyright (C) 2002 Daniel Holth, Clinton McChesney                        */
/*                                                                           */
/* This library is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU Lesser General Public                */
/* License as published by the Free Software Foundation; either              */
/* version 2.1 of the License, or (at your option) any later version.        */
/*                                                                           */
/* This library is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* Lesser General Public License for more details.                           */
/*                                                                           */
/* You should have received a copy of the GNU Lesser General Public          */
/* License along with this library; if not, write to the Free Software       */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* For questions regarding this program contact                              */
/* Daniel Holth <dholth@stetson.edu> or visit                                */
/* http://www.stetson.edu/~ProctoLogic/                                      */

/**
 *  @file BroadcasterNamespace.cc
 *
 *  @author Clinton McChesney
 *  @author Daniel Holth
 */

#include "BroadcasterNamespace.h"

using namespace std;

BroadcasterNamespace::BroadcasterNamespace ()
{
  this -> myBroadcasters = new BroadcasterMap();
}


BroadcasterNamespace::~BroadcasterNamespace ()
{
  delete this->getBroadcasters();
}


bool BroadcasterNamespace::add(string address, Broadcaster * broadcaster)
{
  BroadcasterMap* broadcasters;

  broadcasters = this -> getBroadcasters();
  (*broadcasters)[address] = broadcaster;

  return true;
}


/// remove address from broadcaster namespace
/// return false if not found
bool BroadcasterNamespace::remove(string address)
{
  BroadcasterMap* broadcasters;

  broadcasters = this -> getBroadcasters();
//  Broadcaster *b = (*broadcasters)[address];
//  delete b;
  int removed = (*broadcasters).erase(address);

  return(removed > 0);
}


Broadcaster* BroadcasterNamespace::find(string address)
{
  BroadcasterMap* broadcasters;
  broadcasters = this->getBroadcasters();
  return (*broadcasters)[address];
}


/// Bug:  doesn't check for basename, just returns it all.
vector<string> BroadcasterNamespace::list(string basename)
{
  vector<string> addresses;
  BroadcasterMap *broadcasters;
  BroadcasterMap::iterator iter;
  BroadcasterMap::iterator end;

  broadcasters = this->getBroadcasters();
  
  // size() for the map appears to be twice what it should be!
  // addresses.resize((*callables).size());
  
  iter = (*broadcasters).begin();
  end  = (*broadcasters).end();

  while(iter != end)
  {
    addresses.push_back((*iter).first);
    iter++;
  }
  
  return addresses;
}
