/* Open SoundControl kit in C++                                              */
/* Copyright (C) 2002 Daniel Holth, Clinton McChesney                        */
/*                                                                           */
/* This library is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU Lesser General Public                */
/* License as published by the Free Software Foundation; either              */
/* version 2.1 of the License, or (at your option) any later version.        */
/*                                                                           */
/* This library is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* Lesser General Public License for more details.                           */
/*                                                                           */
/* You should have received a copy of the GNU Lesser General Public          */
/* License along with this library; if not, write to the Free Software       */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* For questions regarding this program contact                              */
/* Daniel Holth <dholth@stetson.edu> or visit                                */
/* http://www.stetson.edu/~ProctoLogic/                                      */

/**
 * @file Processor.cc
 *
 * Prints data.
 * 
 *
 * @author Daniel Holth
 * @author Clinton McChesney
 */

#include "Processor.h"

using namespace std;

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#else
#error "FIXME: place code to deal with no arpa/inet.h here"
#endif

#include <fcntl.h>
#include <iostream>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>

#include "OSCUnpacker.h"

Processor::~Processor() { }

bool Processor::process(const std::string& s, Transmit *const reply)
{
  OSCUnpacker u;
  string address;
  bool success;
  
  
  u.setData(s);
  success = u.unpackString(&address);
 
  if(success)
  {
    cout << "Address: " << address << endl;
  }

  // caller's responsibility.
  // delete reply;
  
  return true;
}
