/* Open SoundControl kit in C++                                              */
/* Copyright (C) 2002 Daniel Holth, Clinton McChesney                        */
/*                                                                           */
/* This library is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU Lesser General Public                */
/* License as published by the Free Software Foundation; either              */
/* version 2.1 of the License, or (at your option) any later version.        */
/*                                                                           */
/* This library is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* Lesser General Public License for more details.                           */
/*                                                                           */
/* You should have received a copy of the GNU Lesser General Public          */
/* License along with this library; if not, write to the Free Software       */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* For questions regarding this program contact                              */
/* Daniel Holth <dholth@stetson.edu> or visit                                */
/* http://www.stetson.edu/~ProctoLogic/                                      */

#include "Subscriber.h"
#include "OSCUnpacker.h"

using namespace std;

void Subscriber::call(const std::string &data, Transmit * const reply)
{
  Broadcaster *bcast;
  OSCUnpacker u;
  string typetag, channel;
  int port;

  bcast = this->getBroadcaster();

  u.setData(data);

  
  u.unpackString(&channel);
  //FIXME: OSCUnpacker::skipString appears not to work!
  //u.skipString(); // the address
  if(u.unpackString(&typetag)) {
      // we might have gotten a port as argument
#ifdef LIBOSC_DEBUG
      cout << "Subscribe request for " << channel << " has typetag: " << typetag << endl;
#endif
      if(u.unpackInt(&port) && typetag == ",i") {
          cout << "Setting return port for this subscription to "<<port<<endl;
          reply->setReturnPort(port);
      }
  }

  cout << "Subscription request from " << reply->getName() << endl;
  bcast->addSubscriber(reply);
}
